package section1;

/**
 * 
 * 1. head will point to the start of the linked list
 * 2. tail will point to the end of the linked list
 * 3. head and tail will be null if the list is empty
 * 
 * 
 * @author wkillian
 *
 * @param <E>
 */
public class SinglyLinkedList<E> implements ListInterface<E> {
	
	private SinglyNode<E> head, tail;
	
	public SinglyLinkedList () {
		head = tail = null;
	}
	
	public void addFirst(E element) {
		head = new SinglyNode<>(element, head);
		if (head.link == null) {
			tail = head;
		}
	}

	public void addLast(E element) {
		if (tail == null) {
			head = tail = new SinglyNode<>(element, null);
		} else {
			tail.link = new SinglyNode<>(element, null);
			tail = tail.link;
		}
	}

	public E removeFirst() {
		if (isEmpty()) {
			return null;
		}
		E data = head.data;
		head = head.link;
		if (head == null) {
			tail = null;
		}
		return data;
	}

	public E getFirst() {
		if (isEmpty())
			return null;
		return head.data;
	}

	public E getLast() {
		if (isEmpty())
			return null;
		return tail.data;
	}
	
	public boolean isEmpty() {
		return head == null;
	}

}
