package section2;

/**
 * 1). head will point to the first node in the linked list
 * 2). tail will point to the last node in the linked list
 * 3). head and tail will both be null if the linked list is empty
 * 
 * 
 * 
 * @author wkillian
 *
 * @param <E>
 */
public class SinglyLinkedList<E> implements LinkedListInterface<E> {

	private SinglyNode<E> head, tail;
	
	SinglyLinkedList() {
		head = tail = null;
	}
	
	@Override
	public void addFirst(E element) {
		head = new SinglyNode<E>(element, head);
		if (tail == null) {
			tail = head;
		}
	}

	@Override
	public void addLast(E element) {
		if (head == null) {
			head = tail = new SinglyNode<>(element);
		} else {
			tail.next = new SinglyNode<E>(element);
			tail = tail.next;
		}
	}

	@Override
	public E removeFirst() {
		E elem = getFirst();
		if (head == tail) {
			head = tail = null;
		} else {
			head = head.next;
		}
		return elem;
	}

	@Override
	public E getFirst() {
		if (head == null) {
			return null;
		}
		return head.data;
	}

	@Override
	public E getLast() {
		if (tail == null) {
			return null;
		}
		return tail.data;
	}

	@Override
	public boolean isEmpty() {
		return head == null;
	}
	
}
